module Hermes
  module RexClient
    class SyncStructuresTask

      def sync(date, client = Hermes::RexClient::Client.new, yopmail = true, dont_update_parent = false)
        start = Time.now

        rex_last_updated = date || Setting.get_settings_for('rexclient').values['rex_last_updated']

        puts '-' * 100
        puts 'Structures lastModifiedDate after date'
        puts '-' * 100
        client.traverse_structures({'traceability.lastModifiedDate' => ">#{date}"}, Proc.new do |rex_entity| 
            className = (rex_entity['idEntityDefinition'] == client.ed_entity) ? 'Hermes::Entity' : 'Hermes::Lessor'
            Hermes::RexClient::UpdateStructureTask.new.update_entity(rex_entity, className, client, dont_update_parent)
          end
        )

        puts '-' * 100
        puts 'Contacts lastModifiedDate after date'
        puts '-' * 100
        client.traverse_contacts({'traceability.lastModifiedDate' => ">#{date}"}, Proc.new do |rex_entity| 
            Hermes::RexClient::UpdateContactTask.new.update_contact(rex_entity, client, yopmail)
          end
        )

        finish = Time.now

        diff = finish - start

        puts '-' * 100
        puts "REX sync took : #{diff} sec"
        puts '-' * 100
      end
    end
  end
end
