# frozen_string_literal: true

require 'rails_helper'

RSpec.describe UpdateScoreFromOfferJob, type: :job do
  let!(:applicant) { create(:applicant, :with_eligible_offers) }

  before(:each) do
    clear_enqueued_jobs
  end

  it 'should create score for given offer' do
    offer = Hermes::HousingOffer.last
    perform_enqueued_jobs do
      expect {
        UpdateScoreFromOfferJob.perform_now(offer.id.to_s, true)
      }.to change {
        Hermes::Score.count
      }.by (1)

      expect(offer.scores).not_to be_blank
    end
  end
end
